<?php
namespace Teknisa\CADCTB\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use \Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;

class Ctb92200PadraoRateiAjustesApuracaoController extends \Teknisa\CADCTB\Controllers\TeknisaCrud {
    
    protected $dataSourceName = "";
    protected $nrorg = "";
    protected $parameterBagColumns = array();
    protected $newCode;
    protected $environment;
    
    public function __construct($crudService, ParameterBag $parameterBag, NewCode $newCode, Environment $environment) {
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->nrorg       = $this->environment->getNrOrg();
        parent::__construct($crudService, $parameterBag);
    }
    
    public function salvarAjusteApur(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            if($row['__is_new'])
                $row ['CDRATEIOPADRAO'] = $this->newCode->getCodeByTableName('CDRATEIOPADRAO', $this->nrorg, 1, 4);
            $this->dataSourceName = "rateiopadraofis";
            parent::save($request, $response);
            $response->addDataSet(new DataSet('row', [$row]));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}


